























MODULE t1_mozcart_Parameters

  USE t1_mozcart_Precision
  PUBLIC
  SAVE



  INTEGER, PARAMETER :: NSPEC = 147 

  INTEGER, PARAMETER :: NVAR = 142 

  INTEGER, PARAMETER :: NVARACT = 141 

  INTEGER, PARAMETER :: NFIX = 5 

  INTEGER, PARAMETER :: NREACT = 335 

  INTEGER, PARAMETER :: NVARST = 1 

  INTEGER, PARAMETER :: NFIXST = 143 

  INTEGER, PARAMETER :: NONZERO = 1396 

  INTEGER, PARAMETER :: LU_NONZERO = 1604 

  INTEGER, PARAMETER :: CNVAR = 143 

  INTEGER, PARAMETER :: NLOOKAT = 0 

  INTEGER, PARAMETER :: NMONITOR = 0 

  INTEGER, PARAMETER :: NMASS = 1 

  REAL(kind=dp), PARAMETER :: PI = 3.14159265358979 




  INTEGER, PARAMETER :: ind_SO4 = 1 
  INTEGER, PARAMETER :: ind_NH3 = 2 
  INTEGER, PARAMETER :: ind_C2H6 = 3 
  INTEGER, PARAMETER :: ind_C3H8 = 4 
  INTEGER, PARAMETER :: ind_CH3CN = 5 
  INTEGER, PARAMETER :: ind_N2O = 6 
  INTEGER, PARAMETER :: ind_SO2 = 7 
  INTEGER, PARAMETER :: ind_EOOH = 8 
  INTEGER, PARAMETER :: ind_IEPOX = 9 
  INTEGER, PARAMETER :: ind_ONITR = 10 
  INTEGER, PARAMETER :: ind_PBZNIT = 11 
  INTEGER, PARAMETER :: ind_C2H2 = 12 
  INTEGER, PARAMETER :: ind_BENZENE = 13 
  INTEGER, PARAMETER :: ind_BEPOMUC = 14 
  INTEGER, PARAMETER :: ind_PHENOL = 15 
  INTEGER, PARAMETER :: ind_HCN = 16 
  INTEGER, PARAMETER :: ind_N2O5 = 17 
  INTEGER, PARAMETER :: ind_TOLUENE = 18 
  INTEGER, PARAMETER :: ind_CRESOL = 19 
  INTEGER, PARAMETER :: ind_TEPOMUC = 20 
  INTEGER, PARAMETER :: ind_XOOH = 21 
  INTEGER, PARAMETER :: ind_XYLENES = 22 
  INTEGER, PARAMETER :: ind_XYLOL = 23 
  INTEGER, PARAMETER :: ind_DMS = 24 
  INTEGER, PARAMETER :: ind_BZALD = 25 
  INTEGER, PARAMETER :: ind_HPALD = 26 
  INTEGER, PARAMETER :: ind_H2O2 = 27 
  INTEGER, PARAMETER :: ind_C6H5OOH = 28 
  INTEGER, PARAMETER :: ind_C2H5OH = 29 
  INTEGER, PARAMETER :: ind_EO = 30 
  INTEGER, PARAMETER :: ind_BIGALD2 = 31 
  INTEGER, PARAMETER :: ind_CH3OOH = 32 
  INTEGER, PARAMETER :: ind_C3H7OOH = 33 
  INTEGER, PARAMETER :: ind_HO2NO2 = 34 
  INTEGER, PARAMETER :: ind_HYDRALD = 35 
  INTEGER, PARAMETER :: ind_MACROOH = 36 
  INTEGER, PARAMETER :: ind_MEKOOH = 37 
  INTEGER, PARAMETER :: ind_BZOOH = 38 
  INTEGER, PARAMETER :: ind_NC4CH2OH = 39 
  INTEGER, PARAMETER :: ind_NTERPOOH = 40 
  INTEGER, PARAMETER :: ind_PHENOOH = 41 
  INTEGER, PARAMETER :: ind_ROOH = 42 
  INTEGER, PARAMETER :: ind_BIGALD4 = 43 
  INTEGER, PARAMETER :: ind_C2H5OOH = 44 
  INTEGER, PARAMETER :: ind_CH3COOH = 45 
  INTEGER, PARAMETER :: ind_C2H4 = 46 
  INTEGER, PARAMETER :: ind_BIGENE = 47 
  INTEGER, PARAMETER :: ind_BIGALK = 48 
  INTEGER, PARAMETER :: ind_ISOPNOOH = 49 
  INTEGER, PARAMETER :: ind_BENZOOH = 50 
  INTEGER, PARAMETER :: ind_XYLOLOOH = 51 
  INTEGER, PARAMETER :: ind_BZOO = 52 
  INTEGER, PARAMETER :: ind_HOCH2OO = 53 
  INTEGER, PARAMETER :: ind_PHENO2 = 54 
  INTEGER, PARAMETER :: ind_BIGALD1 = 55 
  INTEGER, PARAMETER :: ind_CH3COOOH = 56 
  INTEGER, PARAMETER :: ind_ISOPNITB = 57 
  INTEGER, PARAMETER :: ind_HNO3 = 58 
  INTEGER, PARAMETER :: ind_PAN = 59 
  INTEGER, PARAMETER :: ind_PHENO = 60 
  INTEGER, PARAMETER :: ind_POOH = 61 
  INTEGER, PARAMETER :: ind_TERPOOH = 62 
  INTEGER, PARAMETER :: ind_BENZO2 = 63 
  INTEGER, PARAMETER :: ind_XYLOLO2 = 64 
  INTEGER, PARAMETER :: ind_MEK = 65 
  INTEGER, PARAMETER :: ind_HMPROPO2 = 66 
  INTEGER, PARAMETER :: ind_TERPNIT = 67 
  INTEGER, PARAMETER :: ind_H2 = 68 
  INTEGER, PARAMETER :: ind_ACBZO2 = 69 
  INTEGER, PARAMETER :: ind_MPAN = 70 
  INTEGER, PARAMETER :: ind_ISOPNITA = 71 
  INTEGER, PARAMETER :: ind_MBOOOH = 72 
  INTEGER, PARAMETER :: ind_ENEO2 = 73 
  INTEGER, PARAMETER :: ind_BIGALD3 = 74 
  INTEGER, PARAMETER :: ind_TERP2OOH = 75 
  INTEGER, PARAMETER :: ind_EO2 = 76 
  INTEGER, PARAMETER :: ind_CH4 = 77 
  INTEGER, PARAMETER :: ind_C6H5O2 = 78 
  INTEGER, PARAMETER :: ind_ALKOOH = 79 
  INTEGER, PARAMETER :: ind_TOLOOH = 80 
  INTEGER, PARAMETER :: ind_ALKNIT = 81 
  INTEGER, PARAMETER :: ind_MEKO2 = 82 
  INTEGER, PARAMETER :: ind_PO2 = 83 
  INTEGER, PARAMETER :: ind_BIGALD = 84 
  INTEGER, PARAMETER :: ind_ISOPOOH = 85 
  INTEGER, PARAMETER :: ind_XYLENOOH = 86 
  INTEGER, PARAMETER :: ind_MALO2 = 87 
  INTEGER, PARAMETER :: ind_TOLO2 = 88 
  INTEGER, PARAMETER :: ind_HCOOH = 89 
  INTEGER, PARAMETER :: ind_MBO = 90 
  INTEGER, PARAMETER :: ind_XYLENO2 = 91 
  INTEGER, PARAMETER :: ind_DICARBO2 = 92 
  INTEGER, PARAMETER :: ind_C3H7O2 = 93 
  INTEGER, PARAMETER :: ind_O1D = 94 
  INTEGER, PARAMETER :: ind_CH3OH = 95 
  INTEGER, PARAMETER :: ind_C2H5O2 = 96 
  INTEGER, PARAMETER :: ind_MBONO3O2 = 97 
  INTEGER, PARAMETER :: ind_HMPROP = 98 
  INTEGER, PARAMETER :: ind_NC4CHO = 99 
  INTEGER, PARAMETER :: ind_ISOP = 100 
  INTEGER, PARAMETER :: ind_NOA = 101 
  INTEGER, PARAMETER :: ind_APIN = 102 
  INTEGER, PARAMETER :: ind_LIMON = 103 
  INTEGER, PARAMETER :: ind_MYRC = 104 
  INTEGER, PARAMETER :: ind_GLYOXAL = 105 
  INTEGER, PARAMETER :: ind_BCARY = 106 
  INTEGER, PARAMETER :: ind_BPIN = 107 
  INTEGER, PARAMETER :: ind_ALKO2 = 108 
  INTEGER, PARAMETER :: ind_CH3COCH3 = 109 
  INTEGER, PARAMETER :: ind_CO = 110 
  INTEGER, PARAMETER :: ind_GLYALD = 111 
  INTEGER, PARAMETER :: ind_MBOO2 = 112 
  INTEGER, PARAMETER :: ind_TERPROD2 = 113 
  INTEGER, PARAMETER :: ind_TERP2O2 = 114 
  INTEGER, PARAMETER :: ind_C3H6 = 115 
  INTEGER, PARAMETER :: ind_CH3CHO = 116 
  INTEGER, PARAMETER :: ind_MDIALO2 = 117 
  INTEGER, PARAMETER :: ind_TERPO2 = 118 
  INTEGER, PARAMETER :: ind_NTERPO2 = 119 
  INTEGER, PARAMETER :: ind_TERPROD1 = 120 
  INTEGER, PARAMETER :: ind_RO2 = 121 
  INTEGER, PARAMETER :: ind_O = 122 
  INTEGER, PARAMETER :: ind_HYAC = 123 
  INTEGER, PARAMETER :: ind_HONITR = 124 
  INTEGER, PARAMETER :: ind_MACRO2 = 125 
  INTEGER, PARAMETER :: ind_CH3COCHO = 126 
  INTEGER, PARAMETER :: ind_XO2 = 127 
  INTEGER, PARAMETER :: ind_ISOPAO2 = 128 
  INTEGER, PARAMETER :: ind_ISOPNO3 = 129 
  INTEGER, PARAMETER :: ind_ISOPBO2 = 130 
  INTEGER, PARAMETER :: ind_MACR = 131 
  INTEGER, PARAMETER :: ind_CH2O = 132 
  INTEGER, PARAMETER :: ind_MVK = 133 
  INTEGER, PARAMETER :: ind_CH3O2 = 134 
  INTEGER, PARAMETER :: ind_OH = 135 
  INTEGER, PARAMETER :: ind_HO2 = 136 
  INTEGER, PARAMETER :: ind_NO = 137 
  INTEGER, PARAMETER :: ind_NO3 = 138 
  INTEGER, PARAMETER :: ind_MCO3 = 139 
  INTEGER, PARAMETER :: ind_CH3CO3 = 140 
  INTEGER, PARAMETER :: ind_O3 = 141 
  INTEGER, PARAMETER :: ind_NO2 = 142 




  INTEGER, PARAMETER :: ind_M = 143 
  INTEGER, PARAMETER :: ind_H2O = 144 
  INTEGER, PARAMETER :: ind_O2 = 145 
  INTEGER, PARAMETER :: ind_N2 = 146 
  INTEGER, PARAMETER :: ind_CO2 = 147 




  INTEGER, PARAMETER :: indf_M = 1 
  INTEGER, PARAMETER :: indf_H2O = 2 
  INTEGER, PARAMETER :: indf_O2 = 3 
  INTEGER, PARAMETER :: indf_N2 = 4 
  INTEGER, PARAMETER :: indf_CO2 = 5 

END MODULE t1_mozcart_Parameters

